Subject: bug#23425: master branch: `message' wrongly corrupts ' to curly quote.

From: Dmitry Gutov <[email-masked]>
Date: Wed, 4 May 2016 23:23:11 +0300

On 05/04/2016 09:46 PM, John Wiegley wrote:

> As maintainer, I'll go on record by saying that I very much dislike the new
> curly quotes logic. After the reactions I've read here, I'm convinced again
> that a customization option needs to exist in 25.1, so we can easily recommend
> it to people who react as Alan has done.

This doesn't seem like a good idea to me.

If we add a custom option, doesn't that constitute a promise that the 
curly quote translation *will* work for at least several releases of 
Emacs after that?

Because the option would have a value meaning "translate straight quotes 
to curlies", and we'll have to support it once the option is introduced.

> In fact, I would like to rip all the curly-quote redisplay logic out of Emacs,
> for several reasons:

I would too (though I wouldn't actually mind it if it were implemented 
in a very different fashion). But this is a totally different direction 
from "let's add a user option". I think.

>   3. It has provoked heated debate many times already. The amount of time
>      lost on emacs-devel to this one issue is an absolute shame.

Word.

>   4. It changes Emacs according to the preferences of specific people, without
>      giving others -- in the very spirit of Emacs! -- an option to choose
>      one's desired behavior in the standard fashion.
>
> At this point, I cannot undo this feature, since that would destabilize 25.1.

Can we actually leave it in, while all but promising to take it out in 
the next release?

That would seem like an odd choice.

> Lastly, to play devil's advocate: I also recognize, after having written this,
> that I'm something of an "old fogey" in Emacs terms, with a special place for
> ASCII in my heart. It's quite possible that the new-and-coming generation is
> very fond of Unicode, and they will all love this feature, since it gives
> Emacs a more modern "feel". For their sake, I'm prepared to wait for the
> world's judgment before deciding that this feature is entirely terrible.

As a member of a somewhat younger generation, I can say that they look 
fine in Help buffers, manuals, and so on, although they do not look 
"modern". The curly single quotes feel more like certain tech in 
alternative history novels: shiny, could be considered cool in some very 
specific circles, but nobody uses anything like that in the modern times.

I never want to see them in my source code, though, and the benefits, 
whatever they are, do not justify the increased complexity in the 
associated facilities.

> But for the sake of my fellow dinosaurs, I need a way to turn it off! Please!
> They are like tiny knives, stabbing at my mind with their Unicode edges; or a
> plague of typeset locusts, foretelling the soon-to-come Apostroclypse.

The problem with using the "don't translate at all" option is that it 
allows you to write code that won't work for other users.

For instance, if we had such an option now, Alan wouldn't have found the 
presently discussed bug. It wouldn't not manifest with his setup, but it 
would manifest in default Emacs configuration where quote translation is 
enabled, and the majority of the users would suffer.

For that reason only, I'm against having an option like that.